/*
 * Copyright (c) 2001-2003, Adam Dunkels.
 * All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior
 *    written permission.  
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
 *
 * This file is part of the uIP TCP/IP stack.
 *
 * $Id: main.c,v 1.3 2003/12/23 19:25:10 pyrasis Exp $
 *
 */

/*
 * uIP  α׷.
 * Ŀ  ߿ Tun/Tap ö ־  ϴ.
 *
 * ġ  ߵȴ.
 * mknod /dev/net/tun c 10 200
 * 
 * make  ϸ uip    ϰ
 * ifconfig غ tap0 ̴ ġ .
 *
 *   192.168.0.2 ϸ uIP    ȴ.
 */

#include "uip.h"
#include "uip_arp.h"
#include "tapdev.h"
#include "httpd.h"
#include "telnet.h"

#define BUF ((struct uip_eth_hdr *)&uip_buf[0])

#ifndef NULL
#define NULL (void *)0
#endif /* NULL */

/*-----------------------------------------------------------------------------------*/
int
main(void)
{
  u8_t i, arptimer;

  /* Initialize the device driver. */ 
  /* Tap/Tun ̹ ʱȭ */
  tapdev_init();

  /* Initialize the uIP TCP/IP stack. */
  uip_init();

  /* Initialize the HTTP server. */
  /* HTTP  ʱȭ */
  httpd_init();
  
  arptimer = 0;
  
  while(1) {
    /* Let the tapdev network device driver read an entire IP packet
       into the uip_buf. If it must wait for more than 0.5 seconds, it
       will return with the return value 0. If so, we know that it is
       time to call upon the uip_periodic(). Otherwise, the tapdev has
       received an IP packet that is to be processed by uIP. */
    /*
       tapdev Ʈũ ̽ ̹ о ü IP Ŷ uip_buf
        ִ´.  0.5ʸ  Ѵٸ tapdev return 0 ȯ
       Ѵ. ׷ٸ 츮 uip_periodic() ȣ ð̶  
        ִ. ׷  tapdev uIP  ó Ŷ ޴´.*/
    /* 
       extern volatile u16_t uip_len, uip_slen; 
       tapdev_read()   Ŷ ̸ uip_len Ѵ. */
    uip_len = tapdev_read();
    if(uip_len == 0) {
      for(i = 0; i < UIP_CONNS; i++) {
        /* #define uip_periodic(conn) do { uip_conn = &uip_conns[conn]; \
                                           uip_process(UIP_TIMER); } while (0)
           uip.h 
           
           UIP_CONNS 10 
           uipopt.h */
        /*  Ŷ ̰ 0̶, TCP ƾ ó 10 Ѵ. 
            Լ  ȣ Ǿ Ѵ. 
           ø̼ǰ TCP/IP  Ǵ  ߿ Լ̴. */
        uip_periodic(i);
        /* If the above function invocation resulted in data that
           should be sent out on the network, the global variable
           uip_len is set to a value > 0. */
        if(uip_len > 0) {
          /* Ŷ ̰ 0 ũٸ uip_arp_out() arp Ŷ 
             tapdev_send() Ŷ  */
          uip_arp_out();
          tapdev_send();
        }
      }

#if UIP_UDP
      for(i = 0; i < UIP_UDP_CONNS; i++) {
        uip_udp_periodic(i);
        /* If the above function invocation resulted in data that
           should be sent out on the network, the global variable
           uip_len is set to a value > 0. */
        if(uip_len > 0) {
          uip_arp_out();
          tapdev_send();
        }
      }
#endif /* UIP_UDP */
      
      /* Call the ARP timer function every 10 seconds. */
      /* 10  ARP Ÿ̸ Լ ȣ */
      if(++arptimer == 20) {
        uip_arp_timer();
        arptimer = 0;
      }
    
    } else {
      /* Ŷ Ÿ IP̸ uip_arp_ipin()Լ IP ARPó
         uip_input() Ŷ ޴´. */
      if(BUF->type == htons(UIP_ETHTYPE_IP)) {
        uip_arp_ipin();
        uip_input();
        /* If the above function invocation resulted in data that
           should be sent out on the network, the global variable
           uip_len is set to a value > 0. */
        /* Ŷ ̰ 0 ũ ARPŶ  */
        if(uip_len > 0) {
          uip_arp_out();
          tapdev_send();
        }
      /* Ŷ Ÿ ARP̸ uip_arp_arpin() ARP ARPó */
      } else if(BUF->type == htons(UIP_ETHTYPE_ARP)) {
        uip_arp_arpin();
        /* If the above function invocation resulted in data that
           should be sent out on the network, the global variable
           uip_len is set to a value > 0. */
        if(uip_len > 0) {
          tapdev_send();
        }
      }
    }
  }
  return 0;
}
/*-----------------------------------------------------------------------------------*/
void
uip_log(char *m)
{
  printf("uIP log message: %s\n", m);
}
/*-----------------------------------------------------------------------------------*/
